def rendu(somme_a_rendre : int) -> list:
    """ retourne une liste de trois entiers n1, n2 et n3 qui
    correspondent aux nombres de billets de 5 euros (n1) de pièces de 2 euros (n2) et de
    pièces de 1 euro (n3) à rendre afin que le total rendu soit égal à somme_a_rendre."""
    liste = [0,0,0]

    billets = [5,2,1]
    while somme_a_rendre > 0:
        index = 2
        if somme_a_rendre >= billets[0]:
            index = 0
        elif somme_a_rendre >= billets[1]:
            index = 1
        liste[index] += 1
        somme_a_rendre -= billets[index]

    return liste

assert rendu(-3) == [0,0,0]
assert rendu(13) == [2,1,1]
assert rendu(64) == [12,2,0]
assert rendu(89) == [17,2,0]


class Maillon :
    def __init__(self,v) :
        self.valeur = v
        self.suivant = None

class File :
    def __init__(self) :
        self.dernier_file = None

    def enfile(self,element) :
        nouveau_maillon = Maillon(element)
        nouveau_maillon.suivant = self.dernier_file
        self.dernier_file = nouveau_maillon

    def est_vide(self) :
        return self.dernier_file == None

    def affiche(self) :
        maillon = self.dernier_file
        while maillon != None :
            print(maillon.valeur)
            maillon = maillon.suivant

    def defile(self) :
        if not self.est_vide() :
            if self.dernier_file.suivant == None :
                resultat = self.dernier_file.valeur
                self.dernier_file = None
                return resultat
            maillon = self.dernier_file
            while maillon.suivant.suivant != None :
                maillon = maillon.suivant
            resultat = maillon.suivant.valeur
            maillon.suivant = None
            return resultat
        return None

F = File()
assert F.est_vide() == True
F.enfile(2)
F.enfile(5)
F.enfile(7)
assert F.est_vide() == False
assert F.defile() == 2
assert F.defile() == 5
assert F.defile() == 7
assert F.est_vide() == True